clients/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path('<int:pk>/', views.ClientUpdate.as_view(),
         name='client-update'),
    path('rezultate-cautare/', views.search_results, name='search-results'),
    path('', views.clients_view, name='clients'),
]

inregistrari/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(('clients.urls', 'clients'),
                     namespace='clients')),
]

clients/models.py
from django.db import models
from django.urls import reverse
from django.core.validators import RegexValidator


class Client(models.Model):

    nume_validator = RegexValidator(regex='[a-zA-Z\s-]+$', message="Format invalid",
                                    code='invalid_username')
    cnp_validator = RegexValidator(regex='\d{13}', message="CNP-ul trebuie sa contina 13 cifre",
                                   code='invalid_cnp')

    client_id = models.CharField(
        'id client', max_length=50, editable=False, unique=True)
    last_name = models.CharField(
        'nume', max_length=50, validators=[nume_validator])
    first_name = models.CharField(
        'prenume', max_length=50, validators=[nume_validator])
    cnp = models.CharField('cnp', max_length=13, validators=[cnp_validator])

    class Meta:
        verbose_name = 'client'
        verbose_name_plural = 'clienti'

    def __str__(self):
        return f'{self.last_name.capitalize()}-{self.first_name.capitalize()}'

    def get_absolute_url(self):
        return reverse('clients:clients')

clients/forms.py
from django import forms

from .models import Client


class ClientForm(forms.ModelForm):

    class Meta:
        model = Client
        fields = ['last_name', 'first_name', 'cnp']

        widgets = {
            'last_name': forms.TextInput(attrs={'class': 'form-control'}),
            'first_name': forms.TextInput(attrs={'class': 'form-control'}),
            'cnp': forms.TextInput(attrs={'class': 'form-control'}),
        }

clients/views.py
from django.shortcuts import render
from django.views.generic import UpdateView
from django.http import HttpResponseRedirect, HttpResponse
from django.db.models import Q

from datetime import datetime
import openpyxl

from .models import Client
from .forms import ClientForm


def clients_view(request):

    # if this is a POST request we need to process the form data
    if request.method == 'POST':
        # create a form instance and populate it with data from the request:
        form = ClientForm(request.POST)
        clients = Client.objects.all().order_by('-id')
        # check whether it's valid:
        if form.is_valid():
            # process the data in form.cleaned_data as required

            client_id = datetime.now().strftime('%d%m%y') + \
                str(len(Client.objects.all()) + 1)

            client = Client(client_id=client_id,
                            last_name=form.cleaned_data['last_name'],
                            first_name=form.cleaned_data['first_name'],
                            cnp=form.cleaned_data['cnp'])
            client.save()
            # redirect to a new URL:
            return HttpResponseRedirect('.')

        else:

            return render(request, 'clients/clients.html',
                          {'form': form,
                           'clients': clients, })

    # if a GET (or any other method) we'll create a blank form
    else:
        form = ClientForm()
        clients = Client.objects.all().order_by('-id')

    return render(request, 'clients/clients.html',
                  {'form': form,
                   'clients': clients, })


class ClientUpdate(UpdateView):
    model = Client
    template_name = 'clients/client_form.html'
    form_class = ClientForm


def search_results(request):

    if 'q' in request.GET and request.GET['q']:
        q = request.GET['q']

        search_term = Q(last_name__icontains=q) | Q(
            first_name__icontains=q) | Q(cnp__icontains=q)
        clients = Client.objects.filter(search_term)

        return render(request, 'clients/search-results.html',
                      {'clients': clients,
                       'query': q})

    else:
        return HttpResponse('Introduceti un termen de cautare.')


def to_excel(request):

    clients_ids = []
    clients_last_names = []
    clients_first_names = []
    clients_cnps = []

    for client in Client.objects.all():
        clients_ids.append(client.client_id)
    for client in Client.objects.all():
        clients_last_names.append(client.last_name)
    for client in Client.objects.all():
        clients_first_names.append(client.first_name)
    for client in Client.objects.all():
        clients_cnps.append(client.cnp)

    wb = openpyxl.Workbook()
    sheet = wb['Sheet']

    for row in range(1, len(Client.objects.all())):
        for col in range(1, 5):
            value = [clients_ids[row - 1],
                     clients_last_names[row - 1],
                     clients_first_names[row - 1],
                     clients_cnps[row - 1],
                     ]
            sheet.cell(row=row, column=col).value = value[col - 1]

    wb.save('clients.xlsx')

    return HttpResponseRedirect('.')

clients/templates/clients/base.html
<!doctype html>
<html lang="en">

<head>

  <title>Inregistrari</title>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

  <!-- Loads the path to your static files -->
  {% load static %}

  <!-- styles -->
  <!-- Bootstrap 4.0.0 CSS -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm"
    crossorigin="anonymous">

  <!-- Static CSS -->
  <link rel="stylesheet" type="text/css" href="{% static 'clients/style.css' %}">

  <!-- Favicon -->
  <link rel="shortcut icon" href="{% static 'clients/assets/favicon.ico' %}">

</head>

<body>
  <nav class="navbar navbar-expand-md navbar-dark bg-dark">

    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent"
      aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item">
          <a class="nav-link" href="#">Home
            <span class="sr-only">(current)</span>
          </a>
        </li>
        <li class="nav-item">
          <a class="nav-link" href="#">Smt</a>
        </li>
        <li class="nav-item">
          <form class="form-inline my-lg-0" role="search" method="get" action="{% url 'clients:search-results' %}">
            <input class="form-control mr-sm-2" type="search" placeholder="Cauta" aria-label="cauta" name="q">
            <button class="btn btn-outline-success my-2 my-sm-0" type="submit">Cauta</button>
          </form>
        </li>
      </ul>
      {% if user.is_authenticated %}
      <div class="dropdown">
        <button class="btn btn-outline-success dropdown-toggle" type="button" id="dropdown-user-button" data-toggle="dropdown" aria-haspopup="true"
          aria-expanded="false">
          {{ user }}
        </button>
        <div class="dropdown-menu" id="dropdown-user" aria-labelledby="dropdown-user-button">
          <a class="dropdown-item" href="#">Setari cont</a>
          <div class="dropdown-divider"></div>
          <a class="nav-link" href="#" id="logout">
            <i class="fas fa-power-off fa-fw"></i>"Logout
          </a>
        </div>
      </div>
      {% endif %}
    </div>

  </nav>

  <div class="container">
    {% block content %} {% endblock %}
  </div>


  <!-- Bootstrap js -->
  <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN"
    crossorigin="anonymous"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"
    crossorigin="anonymous"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"
    crossorigin="anonymous"></script>
  <!-- FontAwesome -->
  <script defer src="https://use.fontawesome.com/releases/v5.0.1/js/all.js"></script>

  <!-- Static JS -->
  <script src="{% static 'clients/base.js' %}"></script>

</body>

</html>

clients/templates/clients/client_confirm_delete.html
{% extends 'clients/base.html' %} {% block content %}

<form class="form-horizontal mx-2 my-2" action="" method="post">{% csrf_token %}
  <p>Confirmati stergerea clientului: "{{ object }}"?</p>
  <button class="btn btn-danger" type="submit">Accepta</button>
</form>
{% endblock %}

clients/templates/clients/client_form.html
{% extends 'clients/base.html' %} {% block content %} {% load static %}

<div class="row">
  <div class="col-md-2 mx-2 my-2">
    <h2>Client</h2>
  </div>
</div>

<form class="form" id="update-client-form" method="POST" action="" role="form">
  {% csrf_token %} {{ form.non_field_errors }}
  <div class="form-row" id="error-provider-name">
    <div class="form-group col-md-4">
      <span class="text-danger small">{{ form.last_name.errors }}</span>
    </div>
    <div class="form-group col-md-4">
      <span class="text-danger small">{{ form.first_name.errors }}</span>
    </div>
    <div class="form-group col-md-4">
      <span class="text-danger small">{{ form.cnp.errors }}</span>
    </div>
  </div>

  <div class="form-row">

    <div class="form-group col-md-4">
      <label for="{{ form.last_name.id_for_label }}">Nume:</label>
      {{ form.last_name }} {% if form.last_name.help_text %}
      <p class="help">{{ form.last_name.help_text|safe }}</p>
      {% endif %}
    </div>

    <div class="form-group col-md-4">
      <label for="{{ form.first_name.id_for_label }}">Prenume:</label>
      {{ form.first_name }} {% if form.first_name.help_text %}
      <p class="help">{{ form.first_name.help_text|safe }}</p>
      {% endif %}
    </div>

    <div class="form-group col-md-4">
      <label for="{{ form.cnp.id_for_label }}">CNP:</label>
      {{ form.cnp }} {% if form.cnp.help_text %}
      <p class="help">{{ form.cnp.help_text|safe }}</p>
      {% endif %}
    </div>

  </div>

  <button class="btn btn-success" style="width:100px" type="submit">OK</button>

</form>

{% endblock %}

clients/templates/clients/clients.html
{% extends 'clients/base.html' %} {% block content %} {% load static %}

<div class="row">
  <div class="col-md-2 mx-2 my-2">
    <h2>Clienti</h2>
  </div>
</div>

<form class="form" id="add-client-form" method="POST" action="" role="form">
  {% csrf_token %} {{ form.non_field_errors }}
  <div class="form-row" id="error-provider-name">
    <div class="form-group col-md-4">
      <span class="text-danger small">{{ form.last_name.errors }}</span>
    </div>
    <div class="form-group col-md-4">
      <span class="text-danger small">{{ form.first_name.errors }}</span>
    </div>
    <div class="form-group col-md-4">
      <span class="text-danger small">{{ form.cnp.errors }}</span>
    </div>
  </div>

  <div class="form-row">

    <div class="form-group col-md-4">
      <label for="{{ form.last_name.id_for_label }}">Nume:</label>
      {{ form.last_name }} {% if form.last_name.help_text %}
      <p class="help">{{ form.last_name.help_text|safe }}</p>
      {% endif %}
    </div>

    <div class="form-group col-md-4">
      <label for="{{ form.first_name.id_for_label }}">Prenume:</label>
      {{ form.first_name }} {% if form.first_name.help_text %}
      <p class="help">{{ form.first_name.help_text|safe }}</p>
      {% endif %}
    </div>

    <div class="form-group col-md-4">
      <label for="{{ form.cnp.id_for_label }}">CNP:</label>
      {{ form.cnp }} {% if form.cnp.help_text %}
      <p class="help">{{ form.cnp.help_text|safe }}</p>
      {% endif %}
    </div>

  </div>

  <div class="row justify-content-between">
    <div class="col-4">
      <button class="btn btn-success" style="width:100px" type="submit">OK</button>
    </div>
    <div class="co-4">
      <button class="btn btn-info">Exporta excel</button>
    </div>
  </div>
  
  

</form>

<ol reversed class="offset-md-2">

  {% if clients %} {% for client in clients %}

  <li>
    <a href="{% url 'clients:client-update' client.id %}">{{client.client_id}}: {{ client }}</a>
  </li>

  {% endfor %} {% endif %}

</ol>

{% endblock %}

clients/templates/clients/search-results.html
{% extends 'clients/base.html' %} {% block content %}

<h4>Ati cautat pentru:
  <strong>{{ query }}</strong>
</h4>

{% if clients %}
<h4>Gasit {{ clients|length }} clien{{ clients|pluralize:"t,ti" }}:</h4>

<div class=" list-group">
  {% for client in clients %}
  <a href="{% url 'clients:client-update' client.id %}" class="list-group-item">{{ client }}</a>
  {% endfor %}
</div>

{% else %}

<h4>Nici un rezultat pentru elementele cautate.</h4>

{% endif %}
{% endblock %}